<?php

/*
 REBOOT 
 DESTRUCTION DE TOUT LE CONTENU DE /TMP
 v. 0.10 - 06/2009 - SPIP 1.9.2
 Patrick Kuchard - www.encyclopedie-incomplete.com
*/

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/statistiques');

function _PRIVATE_presentation_taille_fichier($n){
  $c=1024;$i=0;$t=$n;
  while($c<$t && $i++<3) $t=$t/$c;
  if (0<$i) $t=sprintf('%01.2f',$t).' '.substr('KMG',$i-1,1);
  else $t.=' ';
  return $t.'o';
}

function exec_reboot_details() {

# elements spip
global 	$connect_statut,
		$connect_toutes_rubriques,
		$connect_id_auteur,
		$couleur_claire, $couleur_foncee;

#
# function requises ...
#
include_spip("inc/reboot_init");
include_spip('inc/affiche_blocs');


# date jour courte sql spip
	$date_auj = date('Y-m-d');

#
# affichage
#
$commencer_page = charger_fonction('commencer_page', 'inc');
echo $commencer_page(_T('reboot:reboot_titre'), "suivi", "reboot_pg");
echo "<a name='haut_page'></a>";

# Vrifier si Admin principal du site
if ($connect_statut != '0minirezo' OR !$connect_toutes_rubriques) {
	echo _T('avis_non_acces_page');
	echo fin_gauche(), fin_page();
	exit;
}

// Against bad configurations
if (get_magic_quotes_gpc()){
    foreach ($_POST as $k=>$v){
        $_POST[$k] = stripslashes($v);
    }
}
// On rcupre ce qu'il y a  rcuprer
foreach ($_POST as $k=>$v){
 $_SESSION[$k] = $v;
}
foreach ($_GET as $k=>$v){
 $_SESSION[$k] = $v;
}
$affichage_destruction_fichier = '';
if(isset($_SESSION['file_destruct'])){
  if(file_exists(_DIR_LOCAL_REBOOT.'/'.$_SESSION['file_destruct'])){
    unlink(_DIR_LOCAL_REBOOT.'/'.$_SESSION['file_destruct']);
    $affichage_destruction_fichier = 	str_replace('%filename%', $_SESSION['file_destruct'],_T('reboot:fichier_detruit'));    
  }
}



debut_gauche();

/*---------------------------------------------------------------------------*\
Affiche le logo reboot + gros titre + datestamp des serveurs PHP et MySQL
\*---------------------------------------------------------------------------*/

	debut_boite_info();
	$q=spip_query("SELECT DATE_FORMAT(NOW(),'%d/%m/%Y %H:%i') as date_serveur");
	$r=spip_fetch_array($q);
	$datetime_sql=$r['date_serveur'];

	$aff.= "<div style='float:left; margin-right:5px; min-height:55px;'>" 
		. "<img src='"._DIR_IMG_REBOOT."reboot_48.png' alt='reboot' />"
		. "</div>";

	$aff.= gros_titre(_T('reboot:reboot_titre'),'',false);

	$aff.= "<div style='clear:both;'></div>"
		. "<div class='cell_info verdana2'>"
		. "<img src='"._DIR_IMG_REBOOT."icon_php.png' align='absmiddle' title='"._T('reboot:date_serveur_php')."' />\n"
		. date('d/m/Y H:i')."<br />"
		. "<img src='"._DIR_IMG_REBOOT."icon_mysql.png' align='absmiddle' title='"._T('reboot:date_serveur_mysql')."' />\n"
		. $datetime_sql
		. "</div>"
		. "<p class='space_10'></p>";
	
  echo $aff;
	fin_boite_info();


/*---------------------------------------------------------------------------*\
Elements divers
\*---------------------------------------------------------------------------*/

	echo "<p class='space_10'></p>";
	debut_boite_info();
	echo _T('reboot:reboot_avertissement');
	fin_boite_info();

	echo "<p class='space_10'></p>";
	debut_boite_info();
	echo _T('reboot:reboot_repertoire_LOCAL');
  $handler = opendir(_DIR_LOCAL_REBOOT);
  $nb = 0;
  // keep going until all files in directory have been read
  while ( ($file = readdir($handler)) && ($nb<20) ) {
        // si $file n'est pas ce repertoire lui mme ou son parent
        // on l'ajoute dans le tableau
        if ($file != '.' && $file != '..'){
            $resultat['element'][$nb] = $file;
            $stats = stat(_DIR_LOCAL_REBOOT.'/'.$file);
            $resultat['size'][$nb] = $stats['size'];
            $resultat['mtime'][$nb] = date("Y-m-d @ H:i:s", $stats['mtime']);
            $nb++;
        }
  }
  closedir($handler);
  if( $nb == 0){
	   echo _T('reboot:reboot_repertoire_LOCAL_vide');
  }else{
    // un petit tri pour faire joli
    for($i=0; $i<$nb; $i++){
		  for($j=$i; $j<$nb; $j++){
		    if($resultat['element'][$i] > $resultat['element'][$j]){
		      $temp = $resultat['element'][$i];
		      $resultat['element'][$i] = $resultat['element'][$j];
		      $resultat['element'][$j] = $temp;
		      $temp = $resultat['size'][$i];
		      $resultat['size'][$i] = $resultat['size'][$j];
		      $resultat['size'][$j] = $temp;
		      $temp = $resultat['mtime'][$i];
		      $resultat['mtime'][$i] = $resultat['mtime'][$j];
		      $resultat['mtime'][$j] = $temp;
        }
		  }      
    }
    echo _T('reboot:reboot_repertoire_LOCAL_plein').'<br />';
    for($i=0; $i<$nb; $i++){
      echo '<li>'.$resultat['element'][$i].'<br />&nbsp;&nbsp;&nbsp;<small>'._PRIVATE_presentation_taille_fichier($resultat['size'][$i]).' / &nbsp;&nbsp;'.$resultat['mtime'][$i].'</small></li>';
    }
    echo '<br /><li><a href="'.generer_url_ecrire("reboot_details").'" title="'._T('reboot:ouvrir_details').'"><img src="'._DIR_IMG_REBOOT.'page_search.png" align="middle" border="0"> '._T('reboot:lien_ouvrir_details').'</a></li>';
  }	
	fin_boite_info();




creer_colonne_droite();
echo "<p class='space_20'></p>";

/*---------------------------------------------------------------------------*\
atteindre page php info
\*---------------------------------------------------------------------------*/
	echo "<p class='space_10'></p>";
	debut_boite_info();
		echo "\n<a href='".generer_url_ecrire("info")."'>"._T('reboot:page_phpinfo')."</a>\n";
	fin_boite_info();


/*---------------------------------------------------------------------------*\
version de mysql du serveur :
\*---------------------------------------------------------------------------*/
	echo "<p class='space_10'></p>";
	debut_boite_info();
		$vers = mysql_query("select version()");
		$rep = mysql_fetch_array($vers);
		echo "MySQL v. ".$rep[0];
	fin_boite_info();

/*---------------------------------------------------------------------------*\
Patrick signe son mefait... si si !
\*---------------------------------------------------------------------------*/
	echo signature_plugin();




debut_droite();

/*---------------------------------------------------------------------------*\
Onglets pages sup.
\*---------------------------------------------------------------------------*/
	echo onglets_reboot(_request('exec'));

  debut_boite_info();
  
  echo str_replace('%DIR_IMG_REBOOT%', _DIR_IMG_REBOOT, _T('reboot:repertoire_tmp_reboot'));
  echo $affichage_destruction_fichier; 

    // Cration d'un tableau qui va recevoir la liste des fichiers
    $resultat = array();
    $nb = 0;
    $total_size = 0; 
    clearstatcache();      
    $handler = opendir(_DIR_LOCAL_REBOOT);
    // keep going until all files in directory have been read
    while ($file = readdir($handler)) {
        // si $file n'est pas ce repertoire lui mme ou son parent
        // on l'ajoute dans le tableau
        if ($file != '.' && $file != '..'){
            $resultat['element'][$nb] = $file;
            $resultat['content'][$nb] = '<code>'.str_replace(' ','&nbsp;',implode('<br>', file(_DIR_LOCAL_REBOOT.'/'.$file))).'</code>';
            $stats = stat(_DIR_LOCAL_REBOOT.'/'.$file);
            $resultat['size'][$nb] = $stats['size'];
            $resultat['mtime'][$nb] = date("Y-m-d @ H:i:s", $stats['mtime']);
            $nb++;
        }
    }
    closedir($handler);
    // un petit tri pour faire joli
    for($i=0; $i<$nb; $i++){
		  for($j=$i; $j<$nb; $j++){
		    if($resultat['element'][$i] > $resultat['element'][$j]){
		      $temp = $resultat['element'][$i];
		      $resultat['element'][$i] = $resultat['element'][$j];
		      $resultat['element'][$j] = $temp;
		      $temp = $resultat['size'][$i];
		      $resultat['size'][$i] = $resultat['size'][$j];
		      $resultat['size'][$j] = $temp;
		      $temp = $resultat['mtime'][$i];
		      $resultat['mtime'][$i] = $resultat['mtime'][$j];
		      $resultat['mtime'][$j] = $temp;
		      $temp = $resultat['content'][$i];
		      $resultat['content'][$i] = $resultat['content'][$j];
		      $resultat['content'][$j] = $temp;
        }
		  }      
    }
    // c'est fait !
    // le tableau des lments
    echo '<form id="elements" name="elements">';
    echo '<table border="0" width="100%">';
    echo '<tr><td></td><td style="border-bottom:solid 1px;"><strong>'._T('reboot:fichier').'</strong></td><td style="border-bottom:solid 1px;"><strong>'._T('reboot:taille').'</strong></td><td style="border-bottom:solid 1px;"><strong>'._T('reboot:derniere_modification').'</strong></td></tr>';
    for($i=0; $i<$nb; $i++){
 			$ifond = $ifond ^ 1;
			$couleur = ($ifond) ? '#FFFFFF' : '#BBDDFF';
      echo '<tr bgcolor="'.$couleur.'"><td>
              <img src="'._DIR_IMG_REBOOT.'page_search.png" alt="Visualiser" title="Visualiser" onmouseover=\'this.style.cursor="hand";this.style.cursor="pointer"\' onclick=\'
                if(document.getElementById("file'.$i.'").style.visibility == "visible"){
                  document.getElementById("file'.$i.'").style.visibility="hidden";
                  document.getElementById("file'.$i.'").style.display="none";
                }else{
                  document.getElementById("file'.$i.'").style.visibility="visible";
                  document.getElementById("file'.$i.'").style.display="block";
                }              
              \'>
              <a href="../tmp/reboot/'.$resultat['element'][$i].'"><img border=0 src="'._DIR_IMG_REBOOT.'page_down.png" alt="T&eacute;l&eacute;charger" title="T&eacute;l&eacute;charger"></a>
              <img src="'._DIR_IMG_REBOOT.'page_remove.png" alt="D&eacute;truire" title="D&eacute;truire" onmouseover=\'this.style.cursor="hand";this.style.cursor="pointer"\' onclick=\'
                if( confirm("'._T('reboot:confirmation_destruction_fichier_tmp_reboot').$resultat['element'][$i].' ?'.'") ){
                  window.location.replace("?exec=reboot_details&file_destruct='.$resultat['element'][$i].'");
                }
              \'>            
      </td><td>'.$resultat['element'][$i].'</td><td>'._PRIVATE_presentation_taille_fichier($resultat['size'][$i]).'</td><td>'.$resultat['mtime'][$i].'</td></tr>
      <tr><td colspan="4"><div id="file'.$i.'" style="visibility:hidden;display:none;border:dashed 1px #969696;">'.$resultat['content'][$i].'</div></td></tr>';
      $total_size += $resultat['size'][$i];
    }
    echo '<tr><td></td><td><strong>'.$nb.' '._T('reboot:elements').'</strong></td><td>'._PRIVATE_presentation_taille_fichier($total_size).'</td><td></td></tr>';
    echo '<tr><td>&nbsp;</td><td></td><td></td><td></td><td></td></tr>';
    echo '</table>';
	fin_boite_info();

# retour haut de page
echo bouton_retour_haut();

echo fin_gauche(), fin_page();

} // fin exec

?>
