<?php

/*
 REBOOT 
 DESTRUCTION DE TOUT LE CONTENU DE /TMP
 v. 0.10 - 06/2009 - SPIP 1.9.2
 Patrick Kuchard - www.encyclopedie-incomplete.com
*/

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/statistiques');

function _PRIVATE_presentation_taille_fichier($n){
  $c=1024;$i=0;$t=$n;
  while($c<$t && $i++<3) $t=$t/$c;
  if (0<$i) $t=sprintf('%01.2f',$t).' '.substr('KMG',$i-1,1);
  else $t.=' ';
  return $t.'o';
}

function _PRIVATE_get_dir_size($dir){
  return exec("du -sb ".$dir." | awk '{print $1}'");
}

function exec_reboot_pg(){

# elements spip
global 	$connect_statut,
		$connect_toutes_rubriques,
		$connect_id_auteur,
		$couleur_claire, $couleur_foncee;

#
# function requises ...
#
include_spip("inc/reboot_init");
include_spip('inc/affiche_blocs');


# date jour courte sql spip
	$date_auj = date('Y-m-d');

#
# affichage
#
$commencer_page = charger_fonction('commencer_page', 'inc');
echo $commencer_page(_T('reboot:reboot_titre'), "suivi", "reboot_pg");
echo "<a name='haut_page'></a>";

# Vrifier si Admin principal du site
if ($connect_statut != '0minirezo' OR !$connect_toutes_rubriques) {
	echo _T('avis_non_acces_page');
	echo fin_gauche(), fin_page();
	exit;
}

debut_gauche();

/*---------------------------------------------------------------------------*\
Affiche le logo reboot + gros titre + datestamp des serveurs PHP et MySQL
\*---------------------------------------------------------------------------*/

	debut_boite_info();
	$q=spip_query("SELECT DATE_FORMAT(NOW(),'%d/%m/%Y %H:%i') as date_serveur");
	$r=spip_fetch_array($q);
	$datetime_sql=$r['date_serveur'];

	$aff.= "<div style='float:left; margin-right:5px; min-height:55px;'>" 
		. "<img src='"._DIR_IMG_REBOOT."reboot_48.png' alt='reboot' />"
		. "</div>";

	$aff.= gros_titre(_T('reboot:reboot_titre'),'',false);

	$aff.= "<div style='clear:both;'></div>"
		. "<div class='cell_info verdana2'>"
		. "<img src='"._DIR_IMG_REBOOT."icon_php.png' align='absmiddle' title='"._T('reboot:date_serveur_php')."' />\n"
		. date('d/m/Y H:i')."<br />"
		. "<img src='"._DIR_IMG_REBOOT."icon_mysql.png' align='absmiddle' title='"._T('reboot:date_serveur_mysql')."' />\n"
		. $datetime_sql
		. "</div>"
		. "<p class='space_10'></p>";
	
  echo $aff;
	fin_boite_info();

/*---------------------------------------------------------------------------*\
Elements divers
\*---------------------------------------------------------------------------*/

	echo "<p class='space_10'></p>";
	debut_boite_info();
	echo _T('reboot:reboot_avertissement');
	fin_boite_info();

	echo "<p class='space_20'></p>";
	
	debut_boite_info();
	echo _T('reboot:reboot_repertoire_LOCAL');
  $handler = opendir(_DIR_LOCAL_REBOOT);
  $nb = 0;
  // keep going until all files in directory have been read
  while ( ($file = readdir($handler)) && ($nb<20) ) {
        // si $file n'est pas ce repertoire lui mme ou son parent
        // on l'ajoute dans le tableau
        if ($file != '.' && $file != '..'){
            $resultat['element'][$nb] = $file;
            $stats = stat(_DIR_LOCAL_REBOOT.'/'.$file);
            $resultat['size'][$nb] = $stats['size'];
            $resultat['mtime'][$nb] = date("Y-m-d @ H:i:s", $stats['mtime']);
            $nb++;
        }
  }
  closedir($handler);
  if( $nb == 0){
	   echo _T('reboot:reboot_repertoire_LOCAL_vide');
  }else{
    // un petit tri pour faire joli
    for($i=0; $i<$nb; $i++){
		  for($j=$i; $j<$nb; $j++){
		    if($resultat['element'][$i] > $resultat['element'][$j]){
		      $temp = $resultat['element'][$i];
		      $resultat['element'][$i] = $resultat['element'][$j];
		      $resultat['element'][$j] = $temp;
		      $temp = $resultat['size'][$i];
		      $resultat['size'][$i] = $resultat['size'][$j];
		      $resultat['size'][$j] = $temp;
		      $temp = $resultat['mtime'][$i];
		      $resultat['mtime'][$i] = $resultat['mtime'][$j];
		      $resultat['mtime'][$j] = $temp;
        }
		  }      
    }
    echo _T('reboot:reboot_repertoire_LOCAL_plein').'<br />';
    for($i=0; $i<$nb; $i++){
      echo '<li>'.$resultat['element'][$i].'<br />&nbsp;&nbsp;&nbsp;<small>'._PRIVATE_presentation_taille_fichier($resultat['size'][$i]).' / &nbsp;&nbsp;'.$resultat['mtime'][$i].'</small></li>';
    }
    echo '<br /><li><a href="'.generer_url_ecrire("reboot_details").'" title="'._T('reboot:ouvrir_details').'"><img src="'._DIR_IMG_REBOOT.'page_search.png" align="middle" border="0"> '._T('reboot:lien_ouvrir_details').'</a></li>';
  }	
	fin_boite_info();

creer_colonne_droite();
echo "<p class='space_20'></p>";

/*---------------------------------------------------------------------------*\
atteindre page php info
\*---------------------------------------------------------------------------*/
	echo "<p class='space_10'></p>";
	debut_boite_info();
		echo "\n<a href='".generer_url_ecrire("info")."'>"._T('reboot:page_phpinfo')."</a>\n";
	fin_boite_info();


/*---------------------------------------------------------------------------*\
version de mysql du serveur :
\*---------------------------------------------------------------------------*/
	echo "<p class='space_10'></p>";
	debut_boite_info();
		$vers = mysql_query("select version()");
		$rep = mysql_fetch_array($vers);
		echo "MySQL v. ".$rep[0];
	fin_boite_info();

/*---------------------------------------------------------------------------*\
Patrick signe son mefait... si si !
\*---------------------------------------------------------------------------*/

echo "<p class='space_20'></p>";

	echo signature_plugin();




debut_droite();

/*---------------------------------------------------------------------------*\
Onglets pages sup.
\*---------------------------------------------------------------------------*/
	echo onglets_reboot(_request('exec'));

	debut_boite_info();
  echo '<strong>'._T('reboot:repertoire_tmp').'</strong><br />'._DIR_TMP_REBOOT.'<br /><br />';
    // Cration d'un tableau qui va recevoir la liste des fichiers
    $resultat = array();
    $tab = array();
    $nb = 0;
    $total_size = 0; 
    clearstatcache();      
    $handler = opendir(_DIR_TMP_REBOOT);
    // keep going until all files in directory have been read
    while ($file = readdir($handler)) {
        // si $file n'est pas ce repertoire lui mme ou son parent
        // on l'ajoute dans le tableau
        if ($file != '.' && $file != '..'){
            $resultat['element'][$nb] = $file;
            $stats = stat(_DIR_TMP_REBOOT.'/'.$file);
            
            if(($stats['mode'] & 0170000) == 040000){ // c'est un rpertoire ! 
              $resultat['type'][$nb] = '<strong>[REP]</strong>';
              $resultat['size'][$nb] = _PRIVATE_get_dir_size(_DIR_TMP_REBOOT.'/'.$file);
              $resultat['mtime'][$nb] = date("Y-m-d @ H:i:s", $stats['mtime']);
              $tab[$file] = $resultat['size'][$nb];
            }else{
              $resultat['type'][$nb] = '';
              $resultat['size'][$nb] = $stats['size'];
              $resultat['mtime'][$nb] = date("Y-m-d @ H:i:s", $stats['mtime']);
              $resultat['content'][$nb] = '<code>'.str_replace(' ','&nbsp;',implode('<br>', file(_DIR_TMP_REBOOT.'/'.$file))).'</code>';             
              $tab['racine'] += $resultat['size'][$nb];
            }
            $nb++;
        }
    }
    closedir($handler);
    // un petit tri pour faire joli
    for($i=0; $i<$nb; $i++){
		  for($j=$i; $j<$nb; $j++){
		    if($resultat['element'][$i] > $resultat['element'][$j]){
		      $temp = $resultat['element'][$i];
		      $resultat['element'][$i] = $resultat['element'][$j];
		      $resultat['element'][$j] = $temp;
		      $temp = $resultat['type'][$i];
		      $resultat['type'][$i] = $resultat['type'][$j];
		      $resultat['type'][$j] = $temp;
		      $temp = $resultat['size'][$i];
		      $resultat['size'][$i] = $resultat['size'][$j];
		      $resultat['size'][$j] = $temp;
		      $temp = $resultat['mtime'][$i];
		      $resultat['mtime'][$i] = $resultat['mtime'][$j];
		      $resultat['mtime'][$j] = $temp;
		      $temp = $resultat['content'][$i];
		      $resultat['content'][$i] = $resultat['content'][$j];
		      $resultat['content'][$j] = $temp;
        }
		  }      
    }
    // c'est fait !
    // petit camembert...
    asort($tab);           
    echo '<center>
          <IMG alt="distribution des tailles des lments" SRC='._DIR_PLUGIN_REBOOT.'inc/reboot_graph_camembert.php?width=480&height=240&values='.htmlspecialchars(serialize($tab)).' border=0>        
          <IMG alt="distribution des tailles des lments" SRC='._DIR_PLUGIN_REBOOT.'inc/reboot_graph_histogramme.php?width=480&height=240&values='.htmlspecialchars(serialize($tab)).' border=0>        
          </center><br /><br />';
    // le tableau des lments
    echo '<form id="elements" name="elements" method="get" action="'.generer_url_ecrire('reboot_action').'">';
    echo '<input type="hidden" id="exec" name="exec" value="reboot_action">';
    echo '<table border="0" width="100%">';
    echo '<tr><td></td><td style="border-bottom:solid 1px;"><strong>'._T('reboot:element').'</strong></td><td style="border-bottom:solid 1px;"><strong>'._T('reboot:type').'</strong></td><td style="border-bottom:solid 1px;"><strong>'._T('reboot:taille').'</strong></td><td style="border-bottom:solid 1px;"><strong>'._T('reboot:derniere_modification').'</strong></td></tr>';
    for($i=0; $i<$nb; $i++){
 			$ifond = $ifond ^ 1;
			$couleur = ($ifond) ? '#FFFFFF' : '#BBDDFF';
      echo '<tr bgcolor="'.$couleur.'"><td><input type="checkbox" id="'.$i.'" name="'.$i.'" checked>';
      if( ($resultat['type'][$i] == '') && ($resultat['size'][$i] >0) ){
        echo '<img src="'._DIR_IMG_REBOOT.'page_search.png" alt="Visualiser" title="Visualiser" onmouseover=\'this.style.cursor="hand";this.style.cursor="pointer"\' onclick=\'
                if(document.getElementById("file'.$i.'").style.visibility == "visible"){
                  document.getElementById("file'.$i.'").style.visibility="hidden";
                  document.getElementById("file'.$i.'").style.display="none";
                }else{
                  document.getElementById("file'.$i.'").style.visibility="visible";
                  document.getElementById("file'.$i.'").style.display="block";
                }              
              \'>';
      }    
      echo '</td><td>'.$resultat['element'][$i].'</td><td><center>'.($resultat['type'][$i] == '<strong>[REP]</strong>' ? '<img src="'._DIR_IMG_REBOOT.'reboot_folder.png">':'<img src="'._DIR_IMG_REBOOT.'reboot_file.png">').'</center></td><td>'._PRIVATE_presentation_taille_fichier($resultat['size'][$i]).'</td><td>'.$resultat['mtime'][$i].'</td></tr>
            <tr><td colspan="5"><div id="file'.$i.'" style="visibility:hidden;display:none;border:dashed 1px #969696;">'.$resultat['content'][$i].'</div></td></tr>';      
      $total_size += $resultat['size'][$i];
    }
    echo '<tr><td></td><td><strong>'.$nb.' '._T('reboot:elements').'</strong></td><td></td><td>'._PRIVATE_presentation_taille_fichier($total_size).'</td><td></td></tr>';
    echo '<tr><td>&nbsp;</td><td></td><td></td><td></td><td></td></tr>';
    echo '<tr><td><img src="'._DIR_IMG_REBOOT.'arrow_ltr.png"></td><td><a href="#" onclick="
      var form = document.all(\'elements\');
      inputs = form.getElementsByTagName(\'input\');
      for(i=0 ; i<inputs.length ; i++){
        if(inputs[i].type==\'checkbox\'){
          inputs[i].checked=true;
        }
      }">'._T('reboot:tout_cocher').'</a><br><a href="#" onclick="
      var form = document.all(\'elements\');
      inputs = form.getElementsByTagName(\'input\');
      for(i=0 ; i<inputs.length ; i++){
        if(inputs[i].type==\'checkbox\'){
          inputs[i].checked=false;
        }
      }">'._T('reboot:tout_decocher').'</a><br><a href="#" onclick="
      var form = document.all(\'elements\');
      inputs = form.getElementsByTagName(\'input\');
      for(i=0 ; i<inputs.length ; i++){
        if(inputs[i].type==\'checkbox\'){
          if(inputs[i].checked==false){inputs[i].checked=true;}else{inputs[i].checked=false;}
        }
      }">'._T('reboot:inverser').'</a></td><td></td><td></td><td></td></tr>';
    echo '</table>';
	fin_boite_info();

	echo '<p class="space_10"></p>';

	debut_boite_info();
  echo '<strong>'._T('reboot:pour_la_selection').'</strong> ('._T('reboot:elements_marques').' <input type="checkbox" checked>)<br /><br />';	
  echo '<ul>';
  echo '<li><input type="radio" value="garde_structure" id="work" name="work" checked> '._T('reboot:garde_structure').'</li>';
  echo '<li><input type="radio" value="destruction_structure" id="work" name="work"> '._T('reboot:destruction_structure').'</li>';
  echo '</ul>';
  echo '<br /><br /><center><input onmouseover="this.style.border=\'2px dashed #878787\';"; onmouseout="this.style.border=\'0px\';" 
                                    type="submit" style="border:0px;
                                                        background: url('._DIR_IMG_REBOOT.'folder_remove_48.png) no-repeat;
                                                        width: 220px;
                                                        height: 50px;
                                                        "
      value="'._T('reboot:destruction_des_elements').'">
  </center><br /><br />';
  echo '</form>';  
	fin_boite_info();


# retour haut de page
echo bouton_retour_haut();

echo fin_gauche(), fin_page();

} // fin exec

?>
