<?php
$stats = unserialize( stripslashes( htmlspecialchars_decode( $_GET['values'] ) ) );
$width = $_GET['width'] ? $_GET['width']:500;
$height = $_GET['height'] ? $_GET['height']:250;

$charsize = max(1,3*($width*$height)/(500*250)); // 1..5
$charsize = min(5,$charsize);

//==============================================================================
 /* $arr = {légende, donnée} */

$taille = count($stats);
$vals = array_values($stats); 
$keys = array_keys($stats); 
$size = $charsize; /* taille de la police, largeur du caractère */
$ifw = imagefontwidth($size);

$w = $width; /* largeur de l'image */
$h = $height; /* hauteur de l'image */
$a = 120*($width*$height)/(500*250); /* grand axe du camembert */
$b = $a/2; /* 60 : petit axe du camembert */
$d = $a/2; /* 60 : "épaisseur" du camembert */
$cx = $w/2-1; /* abscisse du "centre" du camembert */
$cy = ($h-$d)/2; /* 95 : ordonnée du "centre" du camembert */

$A = 138*($width*$height)/(500*250); /* grand axe de l'ellipse "englobante" */
$B = 102*($width*$height)/(500*250); /* petit axe de l'ellipse "englobante" */
$oy = -$d/2; /* -30 : du "centre" du camembert à celui de l'ellipse "englobante"*/


$couleurs = array(	0xFF99CC, 0xFF9900, 0xFFCB03, 0x99CC00, 0x339966, 0x33CCCC, 0x0091C3, 0x969696,
 										0xFFCC99, 0xFF0099, 0xFF03CB, 0x9900CC, 0x336699, 0xCCCC33, 0x00C31C, 0x96AACC);
$nbcouleurs = count($couleurs);

$img=imagecreate($w,$h);
$bgcolor=imagecolorallocate($img,0xFF,0xFF,0xFF);
imagecolortransparent($img,$bgcolor);
$black=imagecolorallocate($img,0,0,0);

/* calcule la somme des données */
// for ($i=$sum=0,$n=count($arr);$i<$n;$i++) $sum+=$arr[$i][0];
$sum = 0;
for ($i=0;$i<$taille;$i++){
  $sum += $vals[$i];
}

 /* fin des préliminaires : on peut vraiment commencer! */
 for (	$i=$v[0]=0,	$x[0]=$cx+$a,	$y[0]=$cy, $doit=true;
				$i<$taille;
				$i++){

   for (	$j=0,	$k=16;
					$j<3;
					$j++,	$k-=8){
	   $t[$j]=($couleurs[$i % $nbcouleurs]>>$k) & 0xFF;
	 }		
   /* détermine les "vraies" couleurs */
 	 $color[$i]=imagecolorallocate($img,$t[0],$t[1],$t[2]);

 	 /* calcule l'angle des différents "secteurs" */
 	 $v[$i+1]=$v[$i]+round($vals[$i]*360/$sum);

 	 if ($doit) { /* détermine les couleurs "ombrées" */
 	   $shade[$i]=imagecolorallocate($img,max(0,$t[0]-50),max(0,$t[1]-50),max(0,$t[2]-50));

     if ($v[$i+1]<180) { /* calcule les coordonnées des différents parallélogrammes */
 		   $x[$i+1]=$cx+$a*cos($v[$i+1]*M_PI/180);
 			 $y[$i+1]=$cy+$b*sin($v[$i+1]*M_PI/180);
     }else{
       $m=$i+1;
 			 $x[$m]=$cx-$a; /* c'est comme si on remplaçait $v[$i+1] par 180° */
 			 $y[$m]=$cy;
 			 $doit=false; /* indique qu'il est inutile de continuer! */
     }
   }
 } 

 /* dessine la "base" du camembert */
 for ($i=0;$i<$m;$i++){
   imagefilledarc($img,$cx,$cy+$d,2*$a,2*$b,$v[$i],$v[$i+1],$shade[$i],IMG_ARC_PIE);
 }

 /* dessine la partie "verticale" du camembert */
 for ($i=0;$i<$m;$i++){
   $area=array($x[$i],$y[$i]+$d,$x[$i],$y[$i],$x[$i+1],$y[$i+1],$x[$i+1],$y[$i+1]+$d);
   imagefilledpolygon($img,$area,4,$shade[$i]);
 }

 /* dessine le dessus du camembert */
 for ($i=0;$i<$taille;$i++){
    imagefilledarc($img,$cx,$cy,2*$a,2*$b,$v[$i],$v[$i+1],$color[$i],IMG_ARC_PIE);
 }

 /*imageellipse($img,$cx,$cy-$oy,2*$A,2*$B,$black); // dessine l'ellipse "englobante" */

 /* dessine les "flêches" et met en place le texte */
 for ($i=0,$AA=$A*$A,$BB=$B*$B;$i<$taille;$i++){
   if ($keys[$i]){
 	   $phi=($v[$i+1]+$v[$i])/2;
 		 /* intersection des "flêches" avec l'ellipse "englobante" */
 		 $px=$a*3*cos($phi*M_PI/180)/4;
 		 $py=$b*3*sin($phi*M_PI/180)/4;
 		 /* équation du 2ème degré avec 2 racines réelles et distinctes */
 		 $U=$AA*$py*$py+$BB*$px*$px;
 		 $V=$AA*$oy*$px*$py;
 		 $W=$AA*$px*$px*($oy*$oy-$BB);
 		 /* calcule le pourcentage à afficher */
 		 $value=number_format(100*$vals[$i]/$sum,2,",","")."%";
 		 /* écrit le texte à droite */
 		 if ($phi<90 || $phi>270) {
 		   $root=(-$V+sqrt($V*$V-$U*$W))/$U;
 			 imageline($img,$px+$cx,$py+$cy,$qx=$root+$cx,$qy=$root*$py/$px+$cy,$black);
 			 imageline($img,$qx,$qy,$qx+10,$qy,$black);

 			 imagestring($img,$size,$qx+14,$qy-12,$keys[$i],$black);
 			 imagestring($img,$size,$qx+14,$qy-2,$value,$black);
     }else{ /* écrit le texte à gauche */
 		   $root=(-$V-sqrt($V*$V-$U*$W))/$U;
 			 imageline($img,$px+$cx,$py+$cy,$qx=$root+$cx,$qy=$root*$py/$px+$cy,$black);
 			 imageline($img,$qx,$qy,$qx-10,$qy,$black);

 			 imagestring($img,$size,$qx-12-$ifw*strlen($keys[$i]),$qy-12,$keys[$i],$black);
 			 imagestring($img,$size,$qx-12-$ifw*strlen($value),$qy-2,$value,$black);
     }
   }  
 }
 Header("Pragma: no-cache");
 Header("Expires: Thu, 26-Oct-1972 12:00:00");
 Header("Content-type: image/png");
 imagepng($img);
 imagedestroy($img);
?>
